using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

[RequireComponent(typeof(Rigidbody2D))]
public class MarcherVersBruit : MonoBehaviour
{
    private UnityAction<object> _EcouteBruit;
    [SerializeField]
    float _ImpulsionReactionBruit = 10.0f;

    Rigidbody2D _RigidBody;

    void Start()
    {
        _RigidBody = GetComponent<Rigidbody2D>();

        _EcouteBruit += ReagitAuBruit;
        EventManager.StartListening(EventManager.PossibleEvent.eBruit, _EcouteBruit);
    }

    void Update()
    {
        
    }

    public void ReagitAuBruit(object InV2OriginBruit)
    {
        Vector2 origineBruit = (Vector2)InV2OriginBruit;
        Vector2 delta = origineBruit - (Vector2)transform.position;
        Vector2 direction = delta.normalized;
        _RigidBody.AddForce(direction * _ImpulsionReactionBruit, ForceMode2D.Impulse);
    }
}
